package composite;

import java.util.*;

import visitors.Visitor;

/**
 * This class implements the composite class of the Composite Pattern 
 */
public class Composite extends Component{
	private String name;

	private Collection<Component> children;

	public Composite (String name) {
		children = new ArrayList<Component>();
		this.name = name;
	}

	public String toString() {
		return name;
	}

	@Override
	public boolean add(Component c) {
		return children.add(c);
	}

	@Override
	public boolean remove(Component c) {
		// TODO Auto-generated method stub
		return children.remove(c);
	}


	@Override
	public Collection<Component> getChildren() {
		// TODO Auto-generated method stub
		return children;
	}


	@Override
	public double getPrice() {
		double price = 0.0; // initialize
		for( Component child: children ) {
			price += child.getPrice();
		}
		return price;
	}


	@Override
	public double getWeight() {
		double weight = 0.0; // initialize
		for( Component child: children ) {
			weight += child.getWeight();
		}
		return weight;
	}


	@Override
	public double getAmps() {
		double amps = 0.0; // initialize
		for( Component child: children ) {
			amps += child.getAmps();
		}
		return amps;
	}

	@Override
	/*package*/ int getFaults() {
		int faults = 0; // initialize
		for( Component child: children ) {
			faults += child.getFaults();
		}
		return faults;
	}

	@Override
	public boolean accept(Visitor v) {
		// TODO Auto-generated method stub
		v.visit(this);
		return true;
	}

}
