package visitors;

import composite.*;

// This Visitor computes the highest cost Component in the collection
// it visits
public class CostVisitor extends Visitor {
	private double highCost = 0;
	
	public CostVisitor() {/*no impl*/}
	
	@Override
	/**
	 * visits a component, getting it's price
	 * Note that composite price is 0 in this version
	 */
	public void visit(Component c) {
		if( c instanceof Composite ) // don't consider Composites
			return;
		System.out.println(c.toString() + ": $" + c.getPrice() );
		if( c.getPrice() > highCost )
			highCost = c.getPrice();
	}
	

	@Override
	/**
	 * return the result of the visits
	 */
	public double getResult() {
		return highCost;
	}

}
