package visitors;

import composite.*;

// This Visitor computes the highest cost Component in the collection
// it visits
public class FaultVisitor extends Visitor {
	private int faults = 0;
	
	public FaultVisitor() {/*no impl*/}
	
	@Override
	/**
	 * visits a component, getting it's price
	 * Note that composite price is 0 in this version
	 */
	public void visit(Component c) {
	}
	
	public void visit(Component.DiagnosticData dd) {
		if( dd.getFaults() > faults )
			faults = dd.getFaults();
	}
	

	@Override
	/**
	 * return the result of the visits
	 */
	public double getResult() {
		return faults;
	}

}
